---------------------
PatchSet 10170 
Date: 2007/11/27 08:12:17
Author: adri
Branch: store_copy
Tag: (none) 
Log:
Merge changes from Squid-2.HEAD.

Members: 
	ChangeLog:1.93->1.93.2.1 
	configure.in:1.184->1.184.2.1 
	doc/release-notes/release-2.6.html:1.47->1.47.2.1 
	doc/release-notes/release-2.6.sgml:1.59->1.59.2.1 
	helpers/basic_auth/DB/.cvsignore:1.2->1.2.2.1 
	helpers/basic_auth/DB/squid_db_auth.in:1.2->1.2.4.1 
	helpers/basic_auth/squid_radius_auth/ChangeLog:1.1->1.1.4.1(DEAD) 
	helpers/basic_auth/squid_radius_auth/Makefile.am:1.1->1.1.4.1 
	helpers/basic_auth/squid_radius_auth/md5.c:1.1->1.1.4.1(DEAD) 
	helpers/basic_auth/squid_radius_auth/md5.h:1.1->1.1.4.1(DEAD) 
	helpers/basic_auth/squid_radius_auth/squid_rad_auth.c:1.1->1.1.4.1 
	helpers/basic_auth/squid_radius_auth/util.c:1.1->1.1.4.1 
	helpers/basic_auth/squid_radius_auth/util.h:1.1->1.1.4.1 
	include/Array.h:1.7->1.7.52.1 
	include/md5.h:1.12->1.12.34.1 
	lib/Array.c:1.6->1.6.52.1 
	lib/Makefile.am:1.10->1.10.18.1 
	lib/md5.c:1.12->1.12.30.1 
	src/HttpHeader.c:1.28->1.28.6.1 
	src/HttpReply.c:1.23->1.23.6.1 
	src/HttpRequest.c:1.17->1.17.10.1 
	src/Makefile.am:1.54->1.54.2.1 
	src/access_log.c:1.43->1.43.2.1 
	src/cache_cf.c:1.102->1.102.2.1 
	src/cf.data.depend:1.1->1.1.4.1 
	src/cf.data.pre:1.209->1.209.2.1 
	src/client_side.c:1.202.2.6->1.202.2.7 
	src/client_side_rewrite.c:1.2.4.1->1.2.4.2 
	src/client_side_storeurl_rewrite.c:1.3.2.1->1.3.2.2 
	src/enums.h:1.62->1.62.2.1 
	src/errorpage.c:1.37->1.37.6.1 
	src/fqdncache.c:1.22->1.22.2.1 
	src/helper.c:1.43->1.43.6.1 
	src/http.c:1.63->1.63.2.1 
	src/ipcache.c:1.25->1.25.2.1 
	src/main.c:1.80->1.80.2.1 
	src/mib.txt:1.9->1.9.4.1 
	src/protos.h:1.146.2.3->1.146.2.4 
	src/redirect.c:1.16->1.16.10.1 
	src/refresh.c:1.15->1.15.6.1 
	src/refresh_check.c:1.2.4.1->1.2.4.2 
	src/stat.c:1.42.2.2->1.42.2.3 
	src/store.c:1.49->1.49.4.1 
	src/store_client.c:1.25.10.4->1.25.10.5 
	src/store_key_md5.c:1.10->1.10.10.1 
	src/store_rewrite.c:1.1.4.1->1.1.4.2 
	src/store_swapmeta.c:1.12->1.12.22.1 
	src/store_update.c:1.2.4.1->1.2.4.2 
	src/structs.h:1.158.2.4->1.158.2.5 
	src/typedefs.h:1.43.2.2->1.43.2.3 
	src/fs/aufs/aiops.c:1.28->1.28.18.1 
	src/fs/aufs/aiops_win32.c:1.4->1.4.28.1 
	src/fs/aufs/store_dir_aufs.c:1.50->1.50.6.1 

Index: squid/ChangeLog
===================================================================
RCS file: /cvsroot/squid-sf//squid/ChangeLog,v
retrieving revision 1.93
retrieving revision 1.93.2.1
diff -u -r1.93 -r1.93.2.1
--- squid/ChangeLog	23 Sep 2007 16:52:56 -0000	1.93
+++ squid/ChangeLog	27 Nov 2007 08:12:17 -0000	1.93.2.1
@@ -39,6 +39,45 @@
 	- Implementation of an external logfile daemon (ie, logging to
 	  a pipe); UDP logging (based in part on work done by Tim Starling)
 
+Changes to squid-2.6.STABLE17 (26 Nov 2007)
+
+	- Fix compile error with old GCC 2.x or other ANSI-C compilers before
+	  C99
+	- Mention the login= cache_peer option in release notes
+	- Fix bad cache_peer example in squid.conf
+	- Bug #2086: Fix a compile-time memory corruption error causing cf_gen
+	  to fail
+	- Bug #2048: Clarify high_memory_warning usage
+	- Reject DNS responses which result in no data
+	- Fix version number in configuration manual
+	- Move cache and request/reply_header_max_size to their proper
+	  sections
+	- Bug #2088: sbrk statistics broken when process size >2GB
+	- Move logopen() much earlier to have fatal startup errors sent to the
+	  proper syslog facility
+	- Fix HTTP/0.9 responses
+	- Correct bad example config for tos_outgoing_tos
+	- Fix grammar in description of mail_program squid.conf option
+	- Ignore Content-Length in chunked responses instead of rejecting the
+	  response as invalid
+	- Documented that http_port no longer have a default
+	- Cleanup of cache digest documentation
+	- Make aufs store rebuilding back off a little if I/O load too high
+	- Bug #2100: Respect DNS ttl=0
+	- Update udp_(incoming|outgoing)_address documentation to reflect
+	  current bahaviour.
+	- Update HTCP documentation
+	- Document the overlapping helper request format
+	- Change priority of proxy auth and extacl provided username in
+	  login=*:pass
+	- pack header entries on cache updates
+	- Make squid_db_auth reopen the database connection on each query by
+	  default
+	- Improve helper debug ouput, including the channel number
+	- Update cachePeerEntry MIB description to mention what is used as
+	  index key
+	- Import squid_radius_auth for authenticating to RADIUS
+
 Changes to squid-2.6.STABLE16 (5 Sep 2007)
 
 	- Test for sys/capability.h linux include file to avoid failing on
Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.184
retrieving revision 1.184.2.1
diff -u -r1.184 -r1.184.2.1
--- squid/configure.in	5 Sep 2007 22:52:14 -0000	1.184
+++ squid/configure.in	27 Nov 2007 08:12:17 -0000	1.184.2.1
@@ -1,7 +1,7 @@
 dnl
 dnl  Configuration input file for Squid
 dnl
-dnl  $Id: configure.in,v 1.184 2007/09/05 22:52:14 squidadm Exp $
+dnl  $Id: configure.in,v 1.184.2.1 2007/11/27 08:12:17 adri Exp $
 dnl
 dnl
 dnl
@@ -10,7 +10,7 @@
 AM_CONFIG_HEADER(include/autoconf.h)
 AC_CONFIG_AUX_DIR(cfgaux)
 AM_INIT_AUTOMAKE
-AC_REVISION($Revision: 1.184 $)dnl
+AC_REVISION($Revision: 1.184.2.1 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AM_MAINTAINER_MODE
 
@@ -686,11 +686,13 @@
   fi
 ])
 
+dnl SSL is not enabled by default.
 AM_CONDITIONAL(ENABLE_SSL, false)
 
 SSLLIB=''
 SSLFLAGS=''
 
+dnl Default is to use OpenSSL when available
 AC_ARG_ENABLE(ssl,
 [  --enable-ssl            Enable ssl gatewaying support using OpenSSL],
 [ if test "$enableval" != "no"; then
@@ -709,8 +711,7 @@
   fi
 ])
 
-AM_CONDITIONAL(NEED_OWN_MD5, true)
-
+dnl User may specify OpenSSL is needed from a non-standard location
 AC_ARG_WITH(openssl,
 [  --with-openssl[=prefix]
 			  Compile with the OpenSSL libraries. The path to
@@ -739,7 +740,6 @@
   AC_DEFINE(USE_OPENSSL, 1, [Define this to make use of the OpenSSL libraries for
 	MD5 calculation rather than Squid's own MD5 implementation
 	or if building with SSL encryption (USE_SSL)])
-  AM_CONDITIONAL(NEED_OWN_MD5, false)
   if test -z "$SSLLIB"; then
     SSLLIB="-lcrypto" # for MD5 routines
   fi
@@ -751,6 +751,7 @@
 fi
 AC_SUBST(SSLLIB)
 
+
 AC_ARG_ENABLE(forw-via-db,
 [  --enable-forw-via-db    Enable Forw/Via database],
 [ if test "$enableval" = "yes" ; then
@@ -1635,6 +1636,7 @@
 	sys/file.h \
 	sys/ioctl.h \
 	sys/mount.h \
+	sys/md5.h \
 	sys/msg.h \
 	sys/prctl.h \
 	sys/resource.h \
@@ -2103,7 +2105,11 @@
 dnl Check for libcrypt
 dnl Some of our helpers use crypt(3) which may be in libc, or in
 dnl libcrypt (eg FreeBSD)
-AC_CHECK_LIB(crypt, crypt, [CRYPTLIB="-lcrypt"])
+AC_CHECK_LIB(crypt, crypt, [CRYPTLIB=" -lcrypt "])
+
+dnl Solaris10 provides MD5 natively through libmd5
+AC_CHECK_LIB(md5, MD5Init, [CRYPTLIB+=" -lmd5 "])
+
 AC_SUBST(CRYPTLIB)
 
 dnl Check for libdl, used by auth_modules/PAM
Index: squid/doc/release-notes/release-2.6.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/release-notes/release-2.6.sgml,v
retrieving revision 1.59
retrieving revision 1.59.2.1
diff -u -r1.59 -r1.59.2.1
--- squid/doc/release-notes/release-2.6.sgml	9 Sep 2007 09:53:06 -0000	1.59
+++ squid/doc/release-notes/release-2.6.sgml	27 Nov 2007 08:12:19 -0000	1.59.2.1
@@ -1,8 +1,8 @@
 <!doctype linuxdoc system>
 <article>
-<title>Squid 2.6.STABLE16 release notes</title>
+<title>Squid 2.6.STABLE17 release notes</title>
 <author>Squid Developers</author>
-<date>$Id: release-2.6.sgml,v 1.59 2007/09/09 09:53:06 squidadm Exp $</date>
+<date>$Id: release-2.6.sgml,v 1.59.2.1 2007/11/27 08:12:19 adri Exp $</date>
 
 <abstract>
 This document contains the release notes for version 2.6 of Squid.
@@ -82,7 +82,7 @@
 
 <sect>Changes to squid.conf
 <p><descrip>
-<tag>http_port</tag>Now takes a list of options in addition to the port address, specifying the purpose of this http_port. Default is plain Internet proxy as usual.
+<tag>http_port</tag>Now takes a list of options in addition to the port address, specifying the purpose of this http_port. Default is plain Internet proxy as usual. Also there is no longer a default port and you must include a http_port directive in your squid.conf if you want Squid to listen for http requests.
 <tag>httpd_accel_* for transparent proxy</tag>Now implemented by the "transparent" http_port option
 <tag>httpd_accel_* for accelerator mode</tag>Now implemented by other options and the http_port accel option. See individual directives below.
 <tag>httpd_accel_host</tag>Replaced by defaultsite http_port option and cache_peer originserver option.
@@ -638,5 +638,20 @@
 				name="ChangeLog"> file for details.
 </itemize>
 
+<sect>Key changes squid-2.6.STABLE16 to 2.6.STABLE17
+
+<p>
+<itemize>
+	<item>A temporary memory leak fixed on cache updates
+	<item>New squid_radius_auth RADIUS authentication helper
+	<item>Documentation cleanups
+	<item>Code cleanups and portability fixes
+	<item>Several minor bugfixes
+	<item>See also the list of <url
+		url="http://www.squid-cache.org/Versions/v2/2.6/changesets/SQUID_2_6_STABLE16.html"
+			name="squid-2.6.STABLE16 changes"> and the <url url="ChangeLog"
+				name="ChangeLog"> file for details.
+</itemize>
+
 </article>
 
Index: squid/helpers/basic_auth/DB/.cvsignore
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/DB/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.2.2.1
diff -u -r1.2 -r1.2.2.1
--- squid/helpers/basic_auth/DB/.cvsignore	3 Sep 2007 04:51:58 -0000	1.2
+++ squid/helpers/basic_auth/DB/.cvsignore	27 Nov 2007 08:12:20 -0000	1.2.2.1
@@ -2,4 +2,4 @@
 Makefile
 Makefile.in
 squid_db_auth
-squid_db_auth.8Makefile.in
+squid_db_auth.8
Index: squid/helpers/basic_auth/DB/squid_db_auth.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/DB/squid_db_auth.in,v
retrieving revision 1.2
retrieving revision 1.2.4.1
diff -u -r1.2 -r1.2.4.1
--- squid/helpers/basic_auth/DB/squid_db_auth.in	22 Aug 2007 06:52:10 -0000	1.2
+++ squid/helpers/basic_auth/DB/squid_db_auth.in	27 Nov 2007 08:12:20 -0000	1.2.4.1
@@ -21,6 +21,7 @@
 my $db_passwdcol = "password";
 my $db_cond = "enabled = 1";
 my $plaintext = 0;
+my $persist = 0;
 
 =pod
 
@@ -66,6 +67,10 @@
 
 Database contains plain-text passwords
 
+=item	B<--persist>
+
+Keep a persistent database connection open between queries. 
+
 =back
 
 =cut
@@ -79,13 +84,30 @@
 	'passwdcol=s' => \$db_passwdcol,
 	'cond=s' => \$db_cond,
 	'plaintext' => \$plaintext,
+	'persist' => \$persist,
 	);
 
-my $dbh = DBI->connect($dsn, $db_user, $db_passwd) || die ("Could not connect to $dsn\n");
+my ($_dbh, $_sth);
 
-my ($sth) = $dbh->prepare("SELECT $db_passwdcol FROM $db_table WHERE $db_usercol = ?" . ($db_cond ne "" ? " AND $db_cond" : "")) || die;
+sub close_db()
+{
+    return if !defined($_dbh);
+    $_dbh->disconnect();
+    undef $_dbh;
+    undef $_sth;
+}
 
-my $status;
+sub open_db()
+{
+    return $_sth if defined $_sth;
+    $_dbh = DBI->connect($dsn, $db_user, $db_passwd);
+    if (!defined $_dbh) {
+    	warn ("Could not connect to $dsn\n");
+	return undef;
+    }
+    $_sth = $_dbh->prepare("SELECT $db_passwdcol FROM $db_table WHERE $db_usercol = ?" . ($db_cond ne "" ? " AND $db_cond" : "")) || die;
+    return $_sth;
+}
 
 sub check_password($$)
 {
@@ -97,20 +119,34 @@
 
     return 0;
 }
+
+sub query_db($) {
+    my ($user) = @_;
+    my ($sth) = open_db() || return undef;
+    if (!$sth->execute($user)) {
+	close_db();
+	open_db() || return undef;
+	$sth->execute($user) || return undef;;
+    }
+    return $sth;
+}
+my $status;
+
 while (<>) {
     my ($user, $password) = split;
     $status = "ERR";
     $user =~ s/%(..)/pack("H*", $1)/ge;
     $password =~ s/%(..)/pack("H*", $1)/ge;
 
-    $status = "ERR internal error";
-    $sth->execute($user) || next;
+    $status = "ERR database error";
+    my $sth = query_db($user) || next;
     $status = "ERR unknown login";
-    my ($row) = $sth->fetchrow_arrayref() || next;
+    my $row = $sth->fetchrow_arrayref() || next;
     $status = "ERR login failure";
     next if (!check_password($password, @$row[0]));
     $status = "OK";
 } continue {
+    close_db() if (!$persist);
     print $status . "\n";
 }
 
Index: squid/helpers/basic_auth/squid_radius_auth/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/squid_radius_auth/Makefile.am,v
retrieving revision 1.1
retrieving revision 1.1.4.1
diff -u -r1.1 -r1.1.4.1
--- squid/helpers/basic_auth/squid_radius_auth/Makefile.am	5 Sep 2007 22:52:16 -0000	1.1
+++ squid/helpers/basic_auth/squid_radius_auth/Makefile.am	27 Nov 2007 08:12:20 -0000	1.1.4.1
@@ -1,7 +1,7 @@
 #
 #  Makefile for the Squid LDAP authentication helper
 #
-#  $Id: Makefile.am,v 1.1 2007/09/05 22:52:16 squidadm Exp $
+#  $Id: Makefile.am,v 1.1.4.1 2007/11/27 08:12:20 adri Exp $
 #
 #  Uncomment and customize the following to suit your needs:
 #
@@ -11,8 +11,8 @@
 EXTRA_DIST		= squid_radius_auth.8
 squid_radius_auth_SOURCES = \
 			squid_rad_auth.c \
-			md5.c md5.h \
 			radius.h \
 			util.c util.h
 
-LDADD = $(XTRA_LIBS)
+LDADD			= -L$(top_builddir)/lib -lmiscutil $(SSLLIB) $(XTRA_LIBS)
+INCLUDES		= -I$(top_srcdir)/include
Index: squid/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c,v
retrieving revision 1.1
retrieving revision 1.1.4.1
diff -u -r1.1 -r1.1.4.1
--- squid/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c	5 Sep 2007 22:52:16 -0000	1.1
+++ squid/helpers/basic_auth/squid_radius_auth/squid_rad_auth.c	27 Nov 2007 08:12:20 -0000	1.1.4.1
@@ -45,21 +45,51 @@
  * and many others
  */
 
+#include	"config.h"
+
+#if HAVE_SYS_TYPES_H
 #include	<sys/types.h>
+#endif
+#if HAVE_SYS_SOCKET_H
 #include	<sys/socket.h>
+#endif
+#if HAVE_NETINET_IN_H
 #include	<netinet/in.h>
+#endif
+#if HAVE_SYS_TIME_H
 #include	<sys/time.h>
+#endif
+#if HAVE_UNISTD_H
 #include	<unistd.h>
+#endif
+#if HAVE_FCNTL_H
 #include	<fcntl.h>
+#endif
 
+#if HAVE_CTYPE_H
 #include	<ctype.h>
+#endif
+#if HAVE_STDIO_H
 #include	<stdio.h>
+#endif
+#if HAVE_UNISTD_H
 #include	<unistd.h>
+#endif
+#if HAVE_NETDB_H
 #include	<netdb.h>
+#endif
+#if HAVE_PWD_H
 #include	<pwd.h>
+#endif
+#if HAVE_STDLIB_H
 #include	<stdlib.h>
+#endif
+#if HAVE_TIME_H
 #include	<time.h>
+#endif
+#if HAVE_STRING_H
 #include	<string.h>
+#endif
 
 #include	"md5.h"
 #include	"radius.h"
@@ -83,8 +113,8 @@
 static char svc_name[MAXLINE] = "radius";
 static int nasport = 111;
 static int nasporttype = 0;
-static UINT4 nas_ipaddr;
-static UINT4 auth_ipaddr;
+static u_int32_t nas_ipaddr;
+static u_int32_t auth_ipaddr;
 static int retries = 30;
 
 char *progname = "squid_rad_auth";
@@ -111,10 +141,22 @@
 }
 
 /*
+ *     MD5 digest
+ */
+static void
+md5_calc(uint8_t out[16], void *in, size_t len)
+{
+    MD5_CTX ctx;
+    MD5Init(&ctx);
+    MD5Update(&ctx, in, len);
+    MD5Final(out, &ctx);
+}
+
+/*
  *    Receive and verify the result.
  */
 static int
-result_recv(UINT4 host, u_short udp_port, char *buffer, int length)
+result_recv(u_int32_t host, u_short udp_port, char *buffer, int length)
 {
     AUTH_HDR *auth;
     int totallen;
@@ -241,7 +283,7 @@
     int secretlen;
     u_char cbc[AUTH_VECTOR_LEN];
     int i, j;
-    UINT4 ui;
+    u_int32_t ui;
     struct sockaddr_in saremote;
     fd_set readfds;
     socklen_t salen;
Index: squid/helpers/basic_auth/squid_radius_auth/util.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/squid_radius_auth/util.c,v
retrieving revision 1.1
retrieving revision 1.1.4.1
diff -u -r1.1 -r1.1.4.1
--- squid/helpers/basic_auth/squid_radius_auth/util.c	5 Sep 2007 22:52:16 -0000	1.1
+++ squid/helpers/basic_auth/squid_radius_auth/util.c	27 Nov 2007 08:12:20 -0000	1.1.4.1
@@ -35,18 +35,42 @@
 "@(#)util.c	1.5 Copyright 1992 Livingston Enterprises Inc\n"
 "		2.1 Copyright 1997 Cistron Internet Services B.V.";
 
+#include	"config.h"
+
+#if HAVE_SYS_TYES_H
 #include	<sys/types.h>
+#endif
+#if HAVE_SYS_SOCKET_H
 #include	<sys/socket.h>
+#endif
+#if HAVE_SYS_TIME_H
 #include	<sys/time.h>
+#endif
+#if HAVE_NETINET_IN_H
 #include	<netinet/in.h>
+#endif
 
+#if HAVE_STDIO_H
 #include	<stdio.h>
+#endif
+#if HAVE_STDLIB_H
 #include	<stdlib.h>
+#endif
+#if HAVE_NETDB_H
 #include	<netdb.h>
+#endif
+#if HAVE_PWD_H
 #include	<pwd.h>
+#endif
+#if HAVE_TIME_H
 #include	<time.h>
+#endif
+#if HAVE_CTYPE_H
 #include	<ctype.h>
+#endif
+#if HAVE_SIGNAL_H
 #include	<signal.h>
+#endif
 
 #include	"md5.h"
 #include	"util.h"
@@ -89,37 +113,37 @@
  *	Return an IP address in host long notation from
  *	one supplied in standard dot notation.
  */
-static UINT4 ipstr2long(char *ip_str)
+static u_int32_t ipstr2long(char *ip_str)
 {
 	char	buf[6];
 	char	*ptr;
 	int	i;
 	int	count;
-	UINT4	ipaddr;
+	u_int32_t	ipaddr;
 	int	cur_byte;
 
-	ipaddr = (UINT4)0;
+	ipaddr = (u_int32_t)0;
 	for(i = 0;i < 4;i++) {
 		ptr = buf;
 		count = 0;
 		*ptr = '\0';
 		while(*ip_str != '.' && *ip_str != '\0' && count < 4) {
 			if(!isdigit(*ip_str)) {
-				return((UINT4)0);
+				return((u_int32_t)0);
 			}
 			*ptr++ = *ip_str++;
 			count++;
 		}
 		if(count >= 4 || count == 0) {
-			return((UINT4)0);
+			return((u_int32_t)0);
 		}
 		*ptr = '\0';
 		cur_byte = atoi(buf);
 		if(cur_byte < 0 || cur_byte > 255) {
-			return((UINT4)0);
+			return((u_int32_t)0);
 		}
 		ip_str++;
-		ipaddr = ipaddr << 8 | (UINT4)cur_byte;
+		ipaddr = ipaddr << 8 | (u_int32_t)cur_byte;
 	}
 	return(ipaddr);
 }
@@ -128,7 +152,7 @@
  *	Return an IP address in host long notation from a host
  *	name or address in dot notation.
  */
-UINT4 get_ipaddr(char *host)
+u_int32_t get_ipaddr(char *host)
 {
 	struct hostent	*hp;
 
@@ -136,9 +160,9 @@
 		return(ipstr2long(host));
 	}
 	else if((hp = gethostbyname(host)) == (struct hostent *)NULL) {
-		return((UINT4)0);
+		return((u_int32_t)0);
 	}
-	return(ntohl(*(UINT4 *)hp->h_addr));
+	return(ntohl(*(u_int32_t *)hp->h_addr));
 }
 
 
Index: squid/helpers/basic_auth/squid_radius_auth/util.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/helpers/basic_auth/squid_radius_auth/util.h,v
retrieving revision 1.1
retrieving revision 1.1.4.1
diff -u -r1.1 -r1.1.4.1
--- squid/helpers/basic_auth/squid_radius_auth/util.h	5 Sep 2007 22:52:16 -0000	1.1
+++ squid/helpers/basic_auth/squid_radius_auth/util.h	27 Nov 2007 08:12:20 -0000	1.1.4.1
@@ -1,2 +1,2 @@
 /* util.c */
-UINT4		get_ipaddr (char *);
+u_int32_t		get_ipaddr (char *);
Index: squid/include/Array.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Array.h,v
retrieving revision 1.7
retrieving revision 1.7.52.1
diff -u -r1.7 -r1.7.52.1
--- squid/include/Array.h	28 Apr 2006 11:10:49 -0000	1.7
+++ squid/include/Array.h	27 Nov 2007 08:12:20 -0000	1.7.52.1
@@ -1,5 +1,5 @@
 /*
- * $Id: Array.h,v 1.7 2006/04/28 11:10:49 squidadm Exp $
+ * $Id: Array.h,v 1.7.52.1 2007/11/27 08:12:20 adri Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -50,6 +50,8 @@
 extern void arrayAppend(Array * s, void *obj);
 extern void arrayInsert(Array * s, void *obj, int position);
 extern void arrayPreAppend(Array * s, int app_count);
+extern void arrayShrink(Array *a, int new_count);
+
 
 
 #endif /* SQUID_ARRAY_H */
Index: squid/include/md5.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/md5.h,v
retrieving revision 1.12
retrieving revision 1.12.34.1
diff -u -r1.12 -r1.12.34.1
--- squid/include/md5.h	29 May 2006 00:14:40 -0000	1.12
+++ squid/include/md5.h	27 Nov 2007 08:12:20 -0000	1.12.34.1
@@ -1,18 +1,18 @@
 #ifndef SQUID_MD5_H
 #define SQUID_MD5_H
 
-#if USE_OPENSSL
+#if HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
 
 /*
  * If Squid is compiled with OpenSSL then we use the MD5 routines
  * from there via some wrapper macros, and the rest of this file is ignored..
  */
+#define USE_SQUID_MD5 0
 
-#if HAVE_OPENSSL_MD5_H
+#if USE_OPENSSL && HAVE_OPENSSL_MD5_H
 #include <openssl/md5.h>
-#else
-#error Cannot find OpenSSL headers
-#endif
 
 /* Hack to adopt Squid to the OpenSSL syntax */
 #define MD5_DIGEST_CHARS MD5_DIGEST_LENGTH
@@ -21,7 +21,28 @@
 #define MD5Update MD5_Update
 #define MD5Final MD5_Final
 
-#else /* USE_OPENSSL */
+#elif USE_OPENSSL && !HAVE_OPENSSL_MD5_H
+#error Cannot find OpenSSL MD5 headers
+
+#elif HAVE_SYS_MD5_H
+/*
+ * Solaris 10 provides MD5 as part of the system.
+ */
+#include <sys/md5.h>
+
+/*
+ * They also define MD5_CTX with different field names
+ * fortunately we do not access it directly in the squid code.
+ */
+
+/* Hack to adopt Squid to the OpenSSL syntax */
+#define MD5_DIGEST_CHARS MD5_DIGEST_LENGTH
+
+#else /* NEED_OWN_MD5 */
+
+ /* Turn on internal MD5 code */
+#undef  USE_SQUID_MD5
+#define USE_SQUID_MD5 1
 
 /*
  * This is the header file for the MD5 message-digest algorithm.
Index: squid/lib/Array.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/Array.c,v
retrieving revision 1.6
retrieving revision 1.6.52.1
diff -u -r1.6 -r1.6.52.1
--- squid/lib/Array.c	28 Apr 2006 11:10:49 -0000	1.6
+++ squid/lib/Array.c	27 Nov 2007 08:12:20 -0000	1.6.52.1
@@ -1,5 +1,5 @@
 /*
- * $Id: Array.c,v 1.6 2006/04/28 11:10:49 squidadm Exp $
+ * $Id: Array.c,v 1.6.52.1 2007/11/27 08:12:20 adri Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -138,3 +138,11 @@
     /* reset, just in case */
     memset(a->items + a->count, 0, (a->capacity - a->count) * sizeof(void *));
 }
+
+void
+arrayShrink(Array *a, int new_count)
+{
+	assert(new_count < a->capacity);
+	assert(new_count >= 0);
+	a->count = new_count;
+}
Index: squid/lib/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/Makefile.am,v
retrieving revision 1.10
retrieving revision 1.10.18.1
diff -u -r1.10 -r1.10.18.1
--- squid/lib/Makefile.am	8 Sep 2006 19:50:55 -0000	1.10
+++ squid/lib/Makefile.am	27 Nov 2007 08:12:20 -0000	1.10.18.1
@@ -13,11 +13,6 @@
 else
 STRSEPSOURCE=
 endif
-if NEED_OWN_MD5
-MD5SOURCE=md5.c
-else
-MD5SOURCE=
-endif
 if ENABLE_WIN32SPECIFIC
 LIBSSPWIN32=libsspwin32.a
 else
@@ -41,7 +36,6 @@
 	@LIBREGEX@ \
 	$(LIBSSPWIN32)
 EXTRA_libmiscutil_a_SOURCES = \
-	md5.c \
 	snprintf.c \
 	strsep.c \
 	win32lib.c
@@ -53,7 +47,7 @@
 	heap.c \
 	html_quote.c \
 	iso3307.c \
-	$(MD5SOURCE) \
+	md5.c \
 	radix.c \
 	rfc1035.c \
 	rfc1123.c \
Index: squid/lib/md5.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/md5.c,v
retrieving revision 1.12
retrieving revision 1.12.30.1
diff -u -r1.12 -r1.12.30.1
--- squid/lib/md5.c	31 May 2006 11:51:11 -0000	1.12
+++ squid/lib/md5.c	27 Nov 2007 08:12:21 -0000	1.12.30.1
@@ -26,11 +26,16 @@
  */
 #include "config.h"
 
-/* MS VisualStudio Projects are monolithic, so we need the following
- * #if to exclude the MD5 code from compile process when we are
- * building the SSL support.
+#include "md5.h"
+
+/*
+ * Now that we have several alternatives the MD5 files are
+ * passed in by default. But a header-selection decides whether
+ * this provided version is to be built.
+ * TODO: may obsolete the MSV #if below.
  */
-#if !USE_SSL
+#if USE_SQUID_MD5
+
 #if HAVE_STRING_H
 #include <string.h>		/* for memcpy() */
 #endif
@@ -41,8 +46,6 @@
 #include <netinet/in.h>		/* for ntohl() */
 #endif
 
-#include "md5.h"
-
 #ifdef WORDS_BIGENDIAN
 void
 byteSwap(uint32_t * buf, unsigned words)
@@ -255,5 +258,5 @@
     buf[3] += d;
 }
 
-#endif
-#endif
+#endif /* !ASM_MD5 */
+#endif /* !USE_SQUID_MD5 */
Index: squid/src/HttpHeader.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpHeader.c,v
retrieving revision 1.28
retrieving revision 1.28.6.1
diff -u -r1.28 -r1.28.6.1
--- squid/src/HttpHeader.c	11 Apr 2007 22:52:54 -0000	1.28
+++ squid/src/HttpHeader.c	27 Nov 2007 08:12:23 -0000	1.28.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpHeader.c,v 1.28 2007/04/11 22:52:54 squidadm Exp $
+ * $Id: HttpHeader.c,v 1.28.6.1 2007/11/27 08:12:23 adri Exp $
  *
  * DEBUG: section 55    HTTP Header
  * AUTHOR: Alex Rousskov
@@ -381,12 +381,34 @@
     }
 }
 
+static void
+httpHeaderRepack(HttpHeader * hdr)
+{
+    HttpHeaderPos dp = HttpHeaderInitPos;
+    HttpHeaderPos pos = HttpHeaderInitPos;
+
+    /* XXX breaks layering for now! ie, getting grubby fingers in without httpHeaderEntryGet() */
+    dp = 0;
+    pos = 0;
+    while (dp < hdr->entries.count) {
+	for (; dp < hdr->entries.count && hdr->entries.items[dp] == NULL; dp++);
+	assert(dp < hdr->entries.count);
+	hdr->entries.items[pos] = hdr->entries.items[dp];
+	if (dp != pos)
+	    hdr->entries.items[dp] = NULL;
+	pos++;
+	dp++;
+    }
+    arrayShrink(&hdr->entries, pos);
+}
+
 /* use fresh entries to replace old ones */
 void
 httpHeaderUpdate(HttpHeader * old, const HttpHeader * fresh, const HttpHeaderMask * denied_mask)
 {
     const HttpHeaderEntry *e;
     HttpHeaderPos pos = HttpHeaderInitPos;
+
     assert(old && fresh);
     assert(old != fresh);
     debug(55, 7) ("updating hdr: %p <- %p\n", old, fresh);
@@ -399,8 +421,17 @@
 	    httpHeaderDelById(old, e->id);
 	else
 	    httpHeaderDelByName(old, strBuf(e->name));
+    }
+    pos = HttpHeaderInitPos;
+    while ((e = httpHeaderGetEntry(fresh, &pos))) {
+	/* deny bad guys (ok to check for HDR_OTHER) here */
+	if (denied_mask && CBIT_TEST(*denied_mask, e->id))
+	    continue;
 	httpHeaderAddClone(old, e);
     }
+
+    /* And now, repack the array to "fill in the holes" */
+    httpHeaderRepack(old);
 }
 
 /* just handy in parsing: resets and returns false */
Index: squid/src/HttpReply.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpReply.c,v
retrieving revision 1.23
retrieving revision 1.23.6.1
diff -u -r1.23 -r1.23.6.1
--- squid/src/HttpReply.c	2 Jun 2007 19:52:18 -0000	1.23
+++ squid/src/HttpReply.c	27 Nov 2007 08:12:23 -0000	1.23.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpReply.c,v 1.23 2007/06/02 19:52:18 squidadm Exp $
+ * $Id: HttpReply.c,v 1.23.6.1 2007/11/27 08:12:23 adri Exp $
  *
  * DEBUG: section 58    HTTP Reply (Response)
  * AUTHOR: Alex Rousskov
@@ -42,9 +42,8 @@
 static HttpHeaderMask Denied304HeadersMask;
 static http_hdr_type Denied304HeadersArr[] =
 {
-    HDR_ALLOW, HDR_CONTENT_ENCODING, HDR_CONTENT_LANGUAGE, HDR_CONTENT_LENGTH,
-    HDR_CONTENT_LOCATION, HDR_CONTENT_RANGE, HDR_LAST_MODIFIED, HDR_LINK,
-    HDR_OTHER
+    HDR_CONTENT_ENCODING, HDR_CONTENT_LANGUAGE, HDR_CONTENT_LENGTH,
+    HDR_CONTENT_LOCATION, HDR_CONTENT_RANGE
 };
 
 /* local routines */
@@ -274,6 +273,7 @@
     /* clean cache */
     httpReplyHdrCacheClean(rep);
     /* update raw headers */
+    httpHeaderDelById(&rep->header, HDR_AGE);
     httpHeaderUpdate(&rep->header, &freshRep->header,
 	(const HttpHeaderMask *) &Denied304HeadersMask);
     /* init cache */
Index: squid/src/HttpRequest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/HttpRequest.c,v
retrieving revision 1.17
retrieving revision 1.17.10.1
diff -u -r1.17 -r1.17.10.1
--- squid/src/HttpRequest.c	21 Jan 2007 14:03:34 -0000	1.17
+++ squid/src/HttpRequest.c	27 Nov 2007 08:12:24 -0000	1.17.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: HttpRequest.c,v 1.17 2007/01/21 14:03:34 squidadm Exp $
+ * $Id: HttpRequest.c,v 1.17.10.1 2007/11/27 08:12:24 adri Exp $
  *
  * DEBUG: section 73    HTTP Request
  * AUTHOR: Duane Wessels
@@ -59,6 +59,7 @@
 	requestAbortBody(req);
     if (req->auth_user_request)
 	authenticateAuthUserRequestUnlock(req->auth_user_request);
+    safe_free(req->store_url);
     safe_free(req->canonical);
     safe_free(req->vary_hdr);
     safe_free(req->vary_headers);
Index: squid/src/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Makefile.am,v
retrieving revision 1.54
retrieving revision 1.54.2.1
diff -u -r1.54 -r1.54.2.1
--- squid/src/Makefile.am	23 Sep 2007 14:51:42 -0000	1.54
+++ squid/src/Makefile.am	27 Nov 2007 08:12:24 -0000	1.54.2.1
@@ -156,6 +156,8 @@
 	cbdata.c \
 	client_db.c \
 	client_side.c \
+	client_side_rewrite.c \
+	client_side_storeurl_rewrite.c \
 	comm.c \
 	$(COMMLOOP_SOURCE) \
 	debug.c \
@@ -223,8 +225,10 @@
 	peer_userhash.c \
 	protos.h \
 	redirect.c \
+	store_rewrite.c \
 	referer.c \
 	refresh.c \
+	refresh_check.c \
 	send-announce.c \
 	$(SNMPSOURCE) \
 	squid.h \
@@ -245,6 +249,7 @@
 	store_swapin.c \
 	store_swapmeta.c \
 	store_swapout.c \
+	store_update.c \
 	structs.h \
 	tools.c \
 	typedefs.h \
Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.43
retrieving revision 1.43.2.1
diff -u -r1.43 -r1.43.2.1
--- squid/src/access_log.c	23 Sep 2007 14:51:42 -0000	1.43
+++ squid/src/access_log.c	27 Nov 2007 08:12:24 -0000	1.43.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: access_log.c,v 1.43 2007/09/23 14:51:42 squidadm Exp $
+ * $Id: access_log.c,v 1.43.2.1 2007/11/27 08:12:24 adri Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
@@ -320,6 +320,8 @@
 
     LFT_SEQUENCE_NUMBER,
 
+    LFT_EXT_FRESHNESS,
+
     LFT_PERCENT			/* special string cases for escaped chars */
 } logformat_bcode_t;
 
@@ -428,6 +430,8 @@
 
     {"ea", LFT_EXT_LOG},
 
+    {"ef", LFT_EXT_FRESHNESS},
+
     {"%", LFT_PERCENT},
 
     {NULL, LFT_NONE}		/* this must be last */
@@ -691,6 +695,12 @@
 	    doint = 1;
 	    break;
 
+	case LFT_EXT_FRESHNESS:
+	    out = al->ext_refresh;
+
+	    quote = 1;
+	    break;
+
 	case LFT_PERCENT:
 	    out = "%";
 	    break;
